function score = ll(param)
global sv pi gxx T xs nstates emax A B C D v gx cnt beta ge Mx Me fp AA BB nn
a = param(1);
sigma = param(2);

LL = 0;

if (a > 0) & (sigma > 0)

    vc = AA + BB/sigma;

    if fp % if fp is set to 1, compute vc as fixed point
        v2=vc;
        v1=vc-0.01;
        while max(abs(v1-v2))>.0001
            v1 = v2;
            v2 = Mx*(pi+beta*(v1+exp(-sigma*v1)/sigma));
        end
        vc=v2;
        
        ve = Me*(pi+beta*(vc+exp(-sigma*vc)/sigma));            
    else    
        ve = C + D/sigma;
    end
    
    % save tst ve vc
    
    if min((ve == 0) * (10000) + ve)*beta*a <= 1 % i.e. if the lowest entrant's payoff is less than 1/a
        score = Inf;
    else
        for q = 1:size(xs,3);
            ts = xs(:,:,q);
            for t=2:T-1
                rr = max(0, (beta*ve(nstates(ts(t,1), ts(t,2)+1, ts(t,1)-ts(t-1,1)+2))-1/a));
                if ve(nstates(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2))>0
                    F = 1 - exp(-a*rr)*(1+a*rr);        
                    LL = LL + ts(t,4)*log(F) + (emax-ts(t,4))*log(1-F);
                end;
                if vc(nstates(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2))>0
                    F = 1-exp(-sigma*vc(nstates(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2)));
                    LL = LL + (ts(t,2)-ts(t,3))*log(F) + ts(t,3)*(-sigma*vc(nstates(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2)));
                end   
            end
        end
        if LL==0
            LL=-Inf;
        end
        
        score=-LL;
        
    end
else
    score = Inf;
end
