% Unstructured
% ts: four columns --- z, n, #exits, #entrants

% global sv Mx Me pi gxx T ts nstates emax
global zmax v xs A B C D cnt gx ge sigma a beta ve emax sv pi gxx T nstates Mx Me fp momcond nn AA BB ii xx

%'Step 1'
setupstart = cputime

%xs's dimensions: time, variable, market#

zmax = 45; %the distribution of changes in z is estimated externally. wlog, zmin = 1
gmax = 3; %also externally
emax = max(max(xs(:,4,:))); % the max number of entrants ever observed
xmax = max(max(xs(:,3,:))); % the max number of exits observed, just for small-sample estimation speed
nmax = max(max(xs(:,2,:))); 
cstates = zeros(zmax, nmax+1, gmax); %count the number of times each state is reached
E = zeros(zmax, nmax+1, gmax);  %count the number of entries in each possible state, including n=nmax
X = zeros(zmax, nmax+1, gmax);  %count the number of exits in each possible state, including n=0
E2 = E;
X2 = X;
% C = zeros(zmax, nmax+1, emax+1, xmax+1);
C=zeros(zmax, nmax+1, gmax, zmax, nmax+1, gmax);
Cx=zeros(zmax, nmax+1, gmax,zmax, nmax+1, gmax);
Ce=zeros(zmax, nmax+1, gmax,zmax, nmax+1, gmax);

%'Step 2'
%cputime

T = size(xs, 1);
Q = size(xs, 3);
for q = 1:Q
    ts = xs(:,:,q);
    for t = 2:T-1
    cstates(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2) = cstates(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2) + 1;
    E(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2) = E(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2) + ts(t,4);
    X(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2) = X(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2) + ts(t,3);    
    E2(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2) = E2(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2) + ts(t,4)^2;
    X2(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2) = X2(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2) + ts(t,3)^2;
    C(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2,ts(t+1,1),ts(t+1,2)+1, ts(t+1,1)-ts(t,1)+2)= ...
        C(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2,ts(t+1,1),ts(t+1,2)+1, ts(t+1,1)-ts(t,1)+2) + 1;
    Cx(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2,ts(t+1,1),ts(t+1,2)+1, ts(t+1,1)-ts(t,1)+2)= ...
        Cx(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2,ts(t+1,1),ts(t+1,2)+1, ts(t+1,1)-ts(t,1)+2) + (ts(t,2)-ts(t,3));
    Ce(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2,ts(t+1,1),ts(t+1,2)+1, ts(t+1,1)-ts(t,1)+2)= ...
        Ce(ts(t,1),ts(t,2)+1, ts(t,1)-ts(t-1,1)+2,ts(t+1,1),ts(t+1,2)+1, ts(t+1,1)-ts(t,1)+2) + ts(t,4);
    end;
end;

%enumerate all encountered states, and record the corresponding numbers

%'Step 3'
%cputime

nstates=zeros(zmax,nmax+1,gmax);
v=[];

for z=1:zmax
    for n=0:nmax
        for g=1:gmax
            if (cstates(z,n+1,g)>0)
                v=[v;z n g];
                nstates(z,n+1,g)=size(v,1);
            end
        end
    end
end

%'Step 4'
%cputime

sv = size(v,1);

% we now record the end-states from which we do not observe any transitions
for q=1:Q
    z = xs(T, 1, q);
    g = z - xs(T-1, 1, q) + 2;
    n = xs(T, 2, q);
    if (nstates(z, n+1, g) == 0)
        v = [v; z n g];
        nstates(z, n+1, g) = size(v, 1);
    end
end

tv = size(v,1); % all "terminal" states are stored from sv+1 to tv

global Evar Xvar

% estimate gx and ge --- average # of exits and entries in each state
gx = zeros(sv,1); 
ge = zeros(sv,1);
cnt = zeros(sv,1);
Evar = zeros(sv,1);
Xvar = zeros(sv,1);
CS = gx;
CE = gx;

for s = 1:sv
    cnt(s) = cstates(v(s,1),v(s,2)+1,v(s,3));
    gx(s) = X(v(s,1),v(s,2)+1,v(s,3))/cnt(s);
    ge(s) = E(v(s,1),v(s,2)+1,v(s,3))/cnt(s);
    CS(s) = (v(s,2)-gx(s))*cnt(s);
    CE(s) = E(v(s,1),v(s,2)+1,v(s,3));
    if cnt(s)>1
         Evar(s) = (E2(v(s,1),v(s,2)+1,v(s,3)) - cnt(s)*(ge(s)^2))/(cnt(s)-1);
         Xvar(s) = (X2(v(s,1),v(s,2)+1,v(s,3)) - cnt(s)*(gx(s)^2))/(cnt(s)-1);
    end;
end

Evar(Evar==0)=mean(Evar(Evar>0)); %when no variance is observed, assign the average var.
Xvar(Xvar==0)=mean(Xvar(Xvar>0));

Evaux=sort(Evar(Evar>0));
Xvaux=sort(Xvar(Xvar>0));

% Xvmax=Xvaux(ceil(.9*size(Xvaux,1)))
% Evmax=Evaux(ceil(.9*size(Evaux,1)))
% Xvmin=Xvaux(ceil(.1*size(Xvaux,1)))
% Evmin=Evaux(ceil(.1*size(Evaux,1)))

% Xvar(Xvar>Xvmax) = Xvmax;
% Xvar(Xvar<Xvmin) = Xvmin;
% Evar(Evar>Evmax) = Evmax;
% Evar(Evar<Evmin) = Evmin;

%'Step 5'
%cputime

% estimate transition probability matrices M, Mx, and Me
% M=zeros(sv);
Mx=zeros(sv, tv);
Me=zeros(sv, tv);

for s1 = 1:sv
    for s2 = 1:tv
%        M(s1,s2)=double(C(v(s1,1),v(s1,2)+1,v(s1,3),v(s2,1),v(s2,2)+1,v(s2,3)))/(cstates(v(s1,1),v(s1,2)+1,v(s1,3)));
        t = double(Cx(v(s1,1),v(s1,2)+1,v(s1,3),v(s2,1),v(s2,2)+1,v(s2,3)));
        if t>0 %i.e. if someone stayed
            Mx(s1,s2)=t/CS(s1);
        end
        t = double(Ce(v(s1,1),v(s1,2)+1,v(s1,3),v(s2,1),v(s2,2)+1,v(s2,3)));
        if t>0 %i.e. if someone entered
            Me(s1,s2)=t/CE(s1);
        end;            
    end    
end

%'Step 6'
%cputime

%Compute one-period profits --- we assume they are known

pi=zeros(tv,1);
for s=1:tv
   pi(s)= profit(v(s,2), v(s,1));
end

gxx=gx;

for s=1:sv
    if v(s,2)>0
        gxx(s)=gx(s)/v(s,2);
    end
end

if (tv > sv)
    gxx = [gxx; zeros(tv - sv, 1)];
    Mx = [Mx; zeros(tv-sv, tv)];
    for s=(sv+1:tv)
        if v(s,2) > 0
            i=1;
            while sum(sum(sum(cstates(max(v(s, 1) - i, 1) : min(v(s, 1) + i, zmax), max(v(s, 2) - i, 1) + 1 : min(v(s, 2) + i, nmax) + 1, max(v(s, 3) - i,1):min(v(s,3)+i, gmax))))) == 0
                i = i + 1;
            end
            sumcnt = sum(sum(sum(cstates(max(v(s, 1) - i, 1) : min(v(s, 1) + i, zmax), max(v(s, 2) - i, 1) + 1 : min(v(s, 2) + i, nmax) + 1, max(v(s, 3) - i,1):min(v(s,3)+i, gmax)))));
            Mline = zeros(1, tv);
            gxxentr = 0;
            for n = max(v(s, 2) - i, 1) : min(v(s, 2) + i, nmax)
                for z = max(v(s, 1) - i, 1) : min(v(s, 1) + i, zmax)
                    for g = max(v(s, 3) - i,1):min(v(s,3)+i, gmax)
                        if cstates(z, n+1, g) > 0 
                            Mline = Mline + (Mx(nstates(z, n+1, g), :) * cstates(z, n+1, g) / sumcnt);
                            gxxentr = gxxentr + (gxx(nstates(z, n+1, g)) * cstates(z, n+1, g) / sumcnt);
                        end
                    end
                end
            end
            Mx(s, :) = Mline;
            gxx(s) = gxxentr;
        end
    end
end

aguess = 1/(sum(CE(1:sv,1).*pi(1:sv,1))/max(.02, sum(CE(1:sv,1))));            
sguess = 1/(sum(CS(1:sv,1).*pi(1:sv,1))/max(.02, sum(CS(1:sv,1))));            

beta = .9;
invshort = inv(eye(tv)-beta*Mx); 
invmat = invshort*Mx;
AA = invmat * pi;
BB = invmat * beta * gxx;
C = Me * (pi + beta * AA);
D = Me * (beta * (BB + gxx));

setupend = cputime;

nn = v(1:sv, 2);
A = AA(1:sv, 1);
B = BB(1:sv, 1);

sest = 0; % for record-keeping purposes; PR = 0

%First---simple estimator, OF=PR=VF=0

init = cputime;
options = optimset('Display','iter');
[sigma,fval,exitflag,output] = fzero(@momx, [0.01 5], options);
cc1 = output.funcCount;
ve=Me*(pi + beta*(AA + (BB+gxx)/sigma));
[a,fval,exitflag,output] = fzero(@mome, [0.01 5], options);
cc1 = cc1 + output.funcCount;
sigma0 = sigma;
a0 = a;

% Setup Time, Function Count, Solver Time, a, sigma, MLE/GMM, Struc/Unstruc, FP/Mat.Inv, ...
sres = [setupend - setupstart, cc1, cputime - init, a, sigma, 0, sest, 0, 0, sv, tv, Q, T, ii];

%Now - fixed point, VF=1

global vvc
init = cputime;
[sigma,fval,exitflag,output] = fzero(@momxfp, [0.01 5], options);
cc1 = output.funcCount;
ve = Me*(pi+beta*(vvc+exp(-sigma*vvc)/sigma));
[a,fval,exitflag,output] = fzero(@mome, [0.01 5], options);
cc1 = cc1 + output.funcCount;
sres = [sres; setupend - setupstart, output.funcCount, cputime - init, a, sigma, 0, sest, 1, 0, sv, tv, Q, T, ii];

% State-specific MOM, OF = 2 (in the code, momcond = 2). Both VF = 0 and VF = 1 (in the code, fp = 0 and fp = 1).
for momcond = 2:2 
    for fp = 0:1
        for grsrch = 0:0
            init = cputime;
            gridsteps = 10;
            gridlow = .1;
            gridstep = .2;
            
            valmin = Inf;
            amin = -1;
            smin = -1;
            
            if grsrch %execute grid search - disabled in the final code
                for apoint = 0:(gridsteps-1)
                    for spoint = 0:(gridsteps-1)
                        vm = momcond2([gridlow+apoint*gridstep; gridlow+spoint*gridstep]); 
                        if  vm < valmin
                            amin = gridlow+apoint*gridstep;
                            smin = gridlow+spoint*gridstep;
                            valmin = vm;
                        end
                    end
                end
            else
                amin = aguess;
                smin = sguess;
            end
            
            options = optimset('Display','iter','MaxFunEvals', 10000, 'MaxIter', 10000);
            fval=0;
            ef=0;
            [z,fval,ef,output]=fminsearch(@momcond2, [amin; smin], options);
            z
            sres = [sres; setupend - setupstart, output.funcCount, cputime - init, z', momcond, sest, fp, grsrch, sv, tv, Q, T, ii];
            
            % when appropriate, save values as first-step estimators
            if (momcond==2) & (fp == 0)
                afstep = z(1,1);
                sfstep = z(2,1);
            end        
        end
    end
end

% Pseudo-MLE, both VF = 0 and VF = 1 (in the code, fp = 0 and fp = 1)

for fp = 0:1
    for grsrch = 0:0
        init = cputime;
        valmin = Inf;
        amin = -1;
        smin = -1;
        
        if grsrch %execute grid search
            for apoint = 0:(gridsteps-1)
                for spoint = 0:(gridsteps-1)
                    vm = ll([gridlow+apoint*gridstep; gridlow+spoint*gridstep]);
                    if  vm < valmin
                        amin = gridlow+apoint*gridstep;
                        smin = gridlow+spoint*gridstep;
                        valmin = vm;
                    end
                end
            end
        else
            amin = aguess;
            smin = sguess;
        end
        
        
        z0 = max([amin; smin],[.01;.01]);
        count = 0;
        while (ll(z0) == Inf) & (count <50)
            z0 = z0 .* [2;1];
            count = count + 1;
            if (amin > 10000)
                 save curioussample
            end
        end
        if (ll(z0)<Inf)
            options = optimset('Display','iter','MaxFunEvals', 1000, 'MaxIter', 1000);
            fval=0;
            ef=0;
            [z,fval,ef,output]=fminsearch(@ll, z0, options);
            ff = z
            sres = [sres; setupend - setupstart, output.funcCount, cputime - init, ff', 1, sest, fp, grsrch, sv, tv, Q, T, ii];
        else
            ff = [0;0]
            sres = [sres; setupend - setupstart, output.funcCount, cputime - init, ff', 1, sest, fp, grsrch, sv, tv, Q, T, ii];
        end
    end
end

sres
